=== meson_options.txt ===
# -*- mode: meson -*-
# SPDX-License-Identifier: GPL-2.0

option('version-tag', type : 'string',
       description : 'override the git version string')
option('vsock', type : 'boolean', value : true,
       description : 'build with vsock support')
option('ptrace', type : 'boolean', value : true,
       description : 'build with ptrace support')
option('htmldir', type : 'string', value : 'share/doc/trace-cmd-doc',
       description : 'directory for HTML documentation')
option('asciidoctor', type : 'boolean', value: false,
       description : 'use asciidoctor instead of asciidoc')
option('docbook-xls-172', type : 'boolean', value : false,
       description : 'enable docbook XLS 172 workaround')
option('asciidoc-no-roff', type : 'boolean', value : false,
       description : 'enable no roff workaround')
option('man-bold-literal', type : 'boolean', value : false,
       description : 'enable bold literals')
option('docbook-suppress-sp', type : 'boolean', value : false,
       description : 'docbook suppress sp')
option('python', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'Generate trac-cmd Python bindings')
option('doc', type : 'boolean', value: true,
       description : 'produce documentation')
option('utest', type : 'boolean', value: true,
       description : 'build utest')
