=== debian/changelog ===
trace-cmd (3.3.3-1) unstable; urgency=medium

  [ Nick Rosbrook ]
  * debian/patches: fallback to using /usr/bin/trace-cmd in trace-utest
  * debian/tests: add trace-utest and trace-cmd-examples dep8 tests

  [ Adriaan Schmidt ]
  * Fix install location for tracecmd.py

  [ Sudip Mukherjee ]
  * New upstream version 3.3.3
  * Fix bash-completion install path.
  * Update Standards-Version to 4.7.2
  * Remove old fsf address from d/copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 29 Aug 2025 22:10:20 +0100
